#include <MC9S08LC60.h> /* include peripheral declarations */
#include <hidef.h> /* for EnableInterrupts macro */
#include <string.h> /* include peripheral declarations */

//******************************************************
#include "lcddrv.h"
//#include "sci.h"
#include "cpu.h"

#include "GD-5506P.h"
#include "GD-5506P_enums.h"


char * LCD_pos[NUMRAMREGS_FORGLASS];
char  LCD_position; 
/*
tU08 *string1, *tstring1,*string, srollstring[128]; 
*/

tU32  odometer_value;   // 1M miles requires at least 20 bits: 
                        // 1M  = 1111 0100 0010 0100 0000  
                        // 99k = 1111 0100 0010 0011 1111

tU08  temperature_value;// Temperature variable                        


//******************************************************
void time_delay(int local_delay)
{
  int i,j,k;
  for (i = 0; i <= local_delay; i++)
  {
    for (j = 0; j <= local_delay; j++)
    {
      for (k = 0; k <= local_delay; k++)
      {
        int l = 0;
      }
    }
  }
}

//******************************************************
void  IO_init()  {
 	//Initialize port direction - OUTPUTS; 
  //******************
 	PTADD_PTADD7 = 1;//output; LED 
 	PTADD_PTADD6 = 1;//output; LED 
 	PTADD_PTADD5 = 1;//output; LED 
 	PTBDD_PTBDD7 = 1;//output; LED 
 	PTBDD_PTBDD6 = 1;//output; LED 
 	PTBDD_PTBDD5 = 1;//output; LED 
 	PTBDD_PTBDD4 = 1;//output; LED 
 	PTBDD_PTBDD3 = 1;//output; LED
 	//Intialize data
 	PTAD_PTAD7 = 1;//output; LED 
 	PTAD_PTAD6 = 1;//output; LED 
 	PTAD_PTAD5 = 1;//output; LED 
 	PTBD_PTBD7 = 1;//output; LED 
 	PTBD_PTBD6 = 1;//output; LED 
 	PTBD_PTBD5 = 1;//output; LED 
 	PTBD_PTBD4 = 1;//output; LED 
 	PTBD_PTBD3 = 1;//output; LED
 	
 	//Intialize data
  PTCDD_PTCDD2 = 1;//output; SPEAKER 

 	//Initialize port direction - INPUTS; 
  //******************
 /*	PTCDD_PTCDD7 = 0;//input - BUTTONS
 	PTCDD_PTCDD5 = 0;//input  - BUTTONS
 	PTCDD_PTCDD4 = 0;//input - BUTTONS*/
 	PTCDD_PTCDD3 = 0;//input  - BUTTONS 

  //KBI intialization
  KBI2PE_KBIPE7 = 1; //PTC7
  KBI2PE_KBIPE6 = 1; //PTC5
  KBI2PE_KBIPE5 = 1; //PTC4
  KBI2SC_KBIE = 1;

}
//******************************************************
void main(void) {
 
  tU08 i,l,V,temperature_ctr;
  byte result, inputcounter, c;
//  byte sci_input[30], cmdstring[30];


  //Initialize CPU and Perpherial 
  //******************
  IO_init();      CPU_init();        LCD_init();
  
//   AS1_Init(); //SCI init
  
  //Intialize LCD glass display
  //******************
  LCD_RAM_SET_ALL(SEGONOFF);      // Set all LCD segments
  LCD_RAM_CLEAR_ALL(SEGONOFF);    // Clear all LCD segments

// LCD_RAM_SET_ALL(SEGONOFF);      // Set all LCD segments - test code

  SET_LOGO(SEGONOFF,ON,ON,ON,ON,ON);          // local_lcdrammode, FSL_logo, HY_64_Part_Num, Jellyfish_Name
  SET_LOGO(SEGBLINKEN,OFF,OFF,OFF,OFF,ON);    // Blink Logo & tentacles

  
  ENABLE_BLINK(ON);      // Enable Blinking   //******************
  EnableInterrupts;      // EnableInterrupts

 
  //Demo Code ******************

  l=0; V=0; temperature_ctr=0; inputcounter = 0;     //Initialize display counters
  odometer_value = 0;                                // Reset Odometer value to 0 at reset
    
//--SET_TEMPSEGS(RAM mode, temp_type, temp_scale, char col4);----------------------
//  SET_TEMPSEGS(SEGONOFF, inside_temp, F,ON);     // Display Temp Segments - Case 1: 
  SET_TEMPSEGS(SEGONOFF, outside_temp,F,ON);     // Display Temp Segments - Case 2
//  SET_TEMPSEGS(SEGONOFF, engine_temp, F,ON);     // Display Temp Segments - Case 3
//  SET_TEMPSEGS(SEGONOFF, inside_temp, C,ON);     // Display Temp Segments - Case 4
//  SET_TEMPSEGS(SEGONOFF, outside_temp,C,ON);     // Display Temp Segments - Case 5
//  SET_TEMPSEGS(SEGONOFF, engine_temp, C,ON);     // Display Temp Segments - Case 6

  while (1)                       //Main LOOP	    
    {

//	  for (i=0; i <= 30; i++);      // delay

 	  if (l == 8) l=0; else l++;;   // Update compass "value"
    SET_GEAR(SEGONOFF,ON,l);      // Rolls through gear selector
    

    switch(l) 
      {
      case 0:   SET_COMPASS(SEGONOFF,ON,N);  break; // update compass
      case 1:   SET_COMPASS(SEGONOFF,ON,NE); break; // update compass
      case 2:   SET_COMPASS(SEGONOFF,ON,E);  break; // update compass
      case 3:   SET_COMPASS(SEGONOFF,ON,SE); break; // update compass
      case 4:   SET_COMPASS(SEGONOFF,ON,S);  break; // update compass
      case 5:   SET_COMPASS(SEGONOFF,ON,SW); break; // update compass
      case 6:   SET_COMPASS(SEGONOFF,ON,W);  break; // update compass
      case 7:   SET_COMPASS(SEGONOFF,ON,NW); break; // update compass
      }

    SET_VOLT_BAR(SEGONOFF,ON, V);
    SET_TEMP_BAR(SEGONOFF,ON, (6-V)); // Update Temp Bar Graph w/inverse of Voltage Graph

 	  if (V == 6) V=0; else V++;;   // Update Voltage Bar Graph "value"
 	  
 	  
 	  SET_TEMP_DIGITS(SEGONOFF,ON,temperature_ctr);   // Update temperature digits with value of i
    temperature_ctr++; if (temperature_ctr==255) temperature_ctr=0;
    
//    SET_ODO_DIGITS(SEGONOFF,ON,odometer_value);   // Update odometer digits with global odometer value
//    odometer_value++; if (odometer_value==1000000) odometer_value=0;
 
    }
  
  for(;;) {
   } /* loop forever */
 }
