#include <hidef.h>

#define HZ_80pin
//#define SWITEC
#define OSCCLK 8
#define BUSCLK 16
#define TIMER_RES 1

#define SendByte(byte) while (SCITxEmpty == 0); \
                       SCI0DRL = byte

#define SCITxEmpty	    SCI0SR1_TDRE 


//----------------------------------
// General Defines - START
//----------------------------------
#define u8  uchar
#define u16 uint
#define u32 ulong
#define s8  uchar
#define s16 uint
#define s32 ulong


#define PIN0 0x01
#define PIN1 0x02
#define PIN2 0x04
#define PIN3 0x08
#define PIN4 0x10
#define PIN5 0x20
#define PIN6 0x40
#define PIN7 0x80

#define CW   0
#define CCW  1

#define ON   1
#define OFF  0

typedef union {
	 struct 
	 	{
		uchar	   bit7: 1;   // upper byte - lsb
		uchar      bit6: 3;
		uchar      bit5: 3;
		uchar      bit4: 3;
		uchar      bit3: 3;
		uchar      bit2: 3;
		uchar      bit1: 3;
		uchar      bit0: 3;
		}BIT;
	uchar BYTE;
} flagtype;	
//----------------------------------
// General Defines - END
//----------------------------------



//----------------------------------
// Motor Paramater Defines - START
//----------------------------------
typedef struct 
    {
    uchar   u8highspeedrtz;    
    uchar   u8oktodetect;
    uchar   u8stopdirection;
    uchar   u8zerostep;
    uchar   u8step;
    uchar   u8_step_state;
    uchar   u8_dir;
    uchar   u8_cmddir;
    uchar   u8_vscaler;
    uchar   u8_fastenable;
    uchar   u8RTZon;
    uint    u8RTZcount;
    uint    u16RTZsteptime;
    uint    u16RTZblankingtime;
    uint    u16RTZintegrationtime;
    uint    u16RTZspeed;
    sint    s16RTZlevel;
    uint    u16_vel;
    uint    u16_cmdvel;
    uint    u16_maxvel;
    ulong   u32_pos;
    ulong   u32_cmdpos;
    }newmtrparams;
//----------------------------------
// Motor Paramater Defines - END
//----------------------------------



//----------------------------------
// SSD Register Defines - START
//----------------------------------
typedef union {
	struct {
		uchar   STEP    :2;			
		uchar 	SMS		:1;
		uchar   unused	:1;
		uchar	POL		:1;
		uchar	RCIR	:1;
		uchar	DCOIL	:1;
		uchar	ITG		:1;
		} bit;
	uchar byte;
}rtzctlreg;

typedef union {
	struct {
		uchar   AOVIE	:1;			
		uchar   unused  :1;
		uchar 	MCEN	:1;
		uchar   FLMC	:1;
		uchar	PRE		:1;
		uchar	RDMCL	:1;
		uchar	MODMC	:1;
		uchar	MCZIE	:1;
		} bit;
	uchar byte;
}mdcctlreg;

typedef union {
	struct {
		uchar 	ACLKS	:2;
		uchar   unused	:2;
		uchar	FTST	:1;
		uchar	SSDWAI	:1;
		uchar	SDCPU	:1;
		uchar	RTZE	:1;
		} bit;
	uchar byte;
}ssdctlreg;

typedef union {
	struct {
		uchar 	AOVIF	:1;
		uchar   unused	:6;
		uchar	MCZIF	:1;
		} bit;
	uchar byte;
}ssdflgreg;

typedef struct {
	rtzctlreg	RTZCTL;
	mdcctlreg 	MDCCTL;
	ssdctlreg	SSDCTL;
	ssdflgreg   SSDFLG;
	uint		MODCNT;
	uint 		ITGACC;
} ssdregs;
//----------------------------------
//  SSD Register Defines - END
//----------------------------------

