//#include "cpu.h"
//#include "Motor_Algo.h"

#ifndef MAIN_H
#define MAIN_H

#define VID

#define M0_STOP_DIRECTION   CCW
#define M1_STOP_DIRECTION   CCW
#define M2_STOP_DIRECTION   CCW
#define M3_STOP_DIRECTION   CCW

#define DEFAULT_DECAY       50
#define DEFAULT_CMDVEL      300
#define DEFAULT_RTZSPEED    40
#define DEFAULT_DETECTDELAY 4


#ifdef MMT

#define MOTOR           MMTmtr
#define MOTOR_TYPE      _90degType
#define MAXVEL          400

#define CWSAMPLEPT0 28     // COIL1 POS current
#define CWSAMPLEPT1 60     // COIL2 POS current
#define CWSAMPLEPT2 92     // COIL1 NEG current
#define CWSAMPLEPT3 124    // COIL2 NEG current

#define CCWSAMPLEPT0 104   // COIL1 POS current
#define CCWSAMPLEPT1 8     // COIL2 POS current
#define CCWSAMPLEPT2 40    // COIL1 NEG current
#define CCWSAMPLEPT3 72    // COIL2 NEG current

#define CLOSEPROXSPEED             55
#define USTEP_THRESHOLD_H         -10 * TIMERCLK  // Change in flyback in us
#define USTEP_THRESHOLD_L         -6  * TIMERCLK  // Change in flyback in us
#define MAXFLYBACK                400 * TIMERCLK  // Max flyback in us
#define STARTSTOPFREQ              60             // STARTSTOPFREQ in deg/s
#define MAXRTZ                    400             // RTZ speed in deg/s

#endif



#ifdef DENSO

#define MOTOR           DENSOmtr
#define MOTOR_TYPE      _90degType
#define MAXVEL          400

#define CWSAMPLEPT0 28
#define CWSAMPLEPT1 60
#define CWSAMPLEPT2 92
#define CWSAMPLEPT3 124

#define CCWSAMPLEPT0 104
#define CCWSAMPLEPT1 8
#define CCWSAMPLEPT2 40
#define CCWSAMPLEPT3 72

#define CLOSEPROXSPEED             40
#define USTEP_THRESHOLD_H         -12 * TIMERCLK  // Change in flyback in us
#define USTEP_THRESHOLD_L         -7  * TIMERCLK  // Change in flyback in us
#define MAXFLYBACK                400 * TIMERCLK  // Max flyback in us
#define STARTSTOPFREQ              60             // STARTSTOPFREQ in deg/s
#define MAXRTZ                    400             // RTZ speed in deg/s

#endif



#ifdef VID    // VID Paramaters

#define MOTOR           VIDmtr
#define MOTOR_TYPE      _60degType
#define MAXVEL          600

#define CWSAMPLEPT0 0
#define CWSAMPLEPT1 40
#define CWSAMPLEPT2 64
#define CWSAMPLEPT3 104

#define CCWSAMPLEPT0 0
#define CCWSAMPLEPT1 40
#define CCWSAMPLEPT2 64
#define CCWSAMPLEPT3 104

#define CLOSEPROXSPEED             50
#define USTEP_THRESHOLD_H         -50 * TIMERCLK  // Change in flyback in us
#define USTEP_THRESHOLD_L         -25 * TIMERCLK  // Change in flyback in us
#define MAXFLYBACK                400 * TIMERCLK  // Max flyback in us
#define STARTSTOPFREQ             62              // STARTSTOPFREQ in deg/s
#define MAXRTZ                    400             // RTZ speed in deg/s

#endif



#ifdef SWITEC    // SWITEC Paramaters

#define MOTOR           SWITECmtr
#define MOTOR_TYPE      _60degType
#define MAXVEL          600

#define CWSAMPLEPT0 0
#define CWSAMPLEPT1 40
#define CWSAMPLEPT2 64
#define CWSAMPLEPT3 104

#define CCWSAMPLEPT0 0
#define CCWSAMPLEPT1 40
#define CCWSAMPLEPT2 64
#define CCWSAMPLEPT3 104

#define CLOSEPROXSPEED             40
#define USTEP_THRESHOLD_H         -50 * TIMERCLK  // Change in flyback in us
#define USTEP_THRESHOLD_L         -25 * TIMERCLK  // Change in flyback in us
#define MAXFLYBACK                400 * TIMERCLK  // Max flyback in us
#define STARTSTOPFREQ              60             // STARTSTOPFREQ in deg/s
#define MAXRTZ                    400             // RTZ speed in deg/s

#endif



//------------------------------------------------------------------
// Globals defined in this file
//------------------------------------------------------------------  
#ifdef MAIN_C
  #define EXT_MAIN_C
#else
  #define EXT_MAIN_C extern
#endif

EXT_MAIN_C motorparams *mtr0,*mtr1,*mtr2,*mtr3;

EXT_MAIN_C s8  samplept;
EXT_MAIN_C u8  DemoState0, DemoState1;
EXT_MAIN_C u8  MotorSelect0,MotorSelect1;
EXT_MAIN_C u8  Delay0,Delay1;
EXT_MAIN_C u8  detectdelay; 
EXT_MAIN_C u8  Motor;
EXT_MAIN_C u16  rtztesting; 

EXT_MAIN_C u16 StartSpeed;
EXT_MAIN_C u16 SweepDelay;
EXT_MAIN_C u16 SettleDelay;

EXT_MAIN_C u16 RTZspeed;
EXT_MAIN_C u16 RTZstartspeed;
EXT_MAIN_C u16 RTZthreshold; 
EXT_MAIN_C u16 ShortIntegrationTime;
EXT_MAIN_C u16 MicroStepIntegrationTime;

EXT_MAIN_C u16 blank;
EXT_MAIN_C u16 integrate;

EXT_MAIN_C u32 rtzpos;
EXT_MAIN_C u32 position0, position1, rtzpos;
EXT_MAIN_C s16 threshold, FSthreshold, MSthreshold;

EXT_MAIN_C u8 SAMPLE0,SAMPLE1,SAMPLE2,SAMPLE3;

//------------------------------------------------------------------


//------------------------------------------------------------------
// Function Prototypes
//------------------------------------------------------------------
#endif