/******************************************************************************
Standard Definitions

These defines allow for easier porting to other compilers. if porting change
these defines to the required values for the chosen compiler.
******************************************************************************/

typedef unsigned char    tU08;   /*unsigned 8 bit definition */
typedef unsigned int    tU16;   /*unsigned 16 bit definition*/
typedef unsigned long   tU32;   /*unsigned 32 bit definition*/
typedef signed char     tS08;   /*signed 8 bit definition */
typedef signed int      tS16;   /*signed 16 bit definition*/
typedef signed long int    	  tS32;   /*signed 32 bit definition*/


#ifndef UINT8
#define	UINT8	tU08			/* unsigned 8-bit */	
#define	UINT16	tU16			/* unsigned 16-bit */
#define	UINT32	tU32			/* unsigned 32-bit */
#define	INT8	tS08			/* signed 8-bit */
#define	INT16	tS16			/* signed 16-bit */
#define	INT32	tS32			/* signed 32-bit */
#endif /* UINT8 */


#ifndef u8
#define u8 tU08
#define u16 tU16
#define u32 tU32
#define s8 tS08
#define s16 tS16
#define s32 tS32
#endif /*u8*/

//========================== compatibility for the SSD driver file=============
/*typedef  unsigned char uchar;
typedef  unsigned int uint;
typedef  unsigned long  ulong;
typedef  signed char   schar;
typedef  signed int  sint;
typedef  signed long   slong;

typedef  unsigned char u8;
typedef  unsigned int u16;
typedef  unsigned long  u32;
typedef  signed char   s8;
typedef  signed int  s16;
typedef  signed long   s32;   */



#define stop()        {asm stop;}
//******************************************************************************
//common labels
#define OFF			  0
#define ON        1
#define NO			  0
#define YES       1
//#define FALSE			0
//#define TRUE      1

/************************* #defines ******************************************/
#define ALL_FULL_DRIVE		0x00   
#define ALL_REDUCED_DRIVE	0xFF

#define ALL_PULLS_OFF		  0x00
#define ALL_PULLS_ON	    0xFF

#define ALL_PULLED_UP		  0x00   
#define ALL_PULLED_DOWN		0xFF

#define ALL_INPUTS			  0x00
#define ALL_OUTPUTS			  0xFF	

#define ALL_LOW				    0x00
#define ALL_HIGH			    0xFF

#define ms_Delay_Cnt			0x1F40		// count used in Delay_1ms routine


#define select_sw   PT1AD_PT1AD4
#define menu_sw     PT1AD_PT1AD5
#define right_sw    PT1AD_PT1AD6
#define left_sw     PT1AD_PT1AD7


//#define SW1				PT1AD_PT1AD4
//#define SW2				PT1AD_PT1AD5
//#define SW3				PT1AD_PT1AD6
//#define SW4				PT1AD_PT1AD7

#define TRANSDEMO		1
#define TEMPDEMO		2
#define ODODEMO	  	4
#define FCDEMO			8

#define left_LED    PTR_PTR0
#define right_LED   PTR_PTR1

//#define LED1			PTR_PTR0
//#define LED2			PTR_PTR1
//#define LED3			PTR_PTR2
//#define LED4			PTR_PTR3

#define LOFF			0x01
#define LON				0x00

//#define LEDS_OFF		PTR_PTR0 = 1, PTR_PTR1 = 1, PTR_PTR2 = 1, PTS_PTS4;


/************************* Prototypes ****************************************/

void Configure_Ports(void);		// configure ports
void CRG_8MHz(void);			// PEE mode, CPUCLK - 16MHz, BUSCLK - 8MHz
void CPMU_PEE_4MHz(void);			// PEE mode, CPUCLK - 8MHz, BUSCLK - 4MHz
void CPMU_PBE(void);					// PBE mode from ext 8MHz XTAL, CPUCLK - 8MHz, BUSCLK - 4MHz
//void Tim0_Dly(void);					// starts T0_C7 and waits for C7 flag to set
//void Init_Timer1(void);				// init Timer1
//void Delay_1ms(void);				// add 1ms delay
//void init_atd_ch0(void);			// init ATD CH0
//void Get_Pot_Val(void);				// read POT and load CAN tx buffer
void MDelay(int delayTime);
void PWM_SOUND(void);          //set PWM Ch3 for sound generation

//void Toggle_Led(byte num);			 Toggle LED based on input

//void Delay(word count);				// Add (count)ms delay 
//byte read_atd_ch0(void);			// read and return ATDCH0 value



 // Global variables
//extern byte kbi_state;

//#endif  			// _cpu_h_


/*

//=======================================================
//Select a clock mode
//=======================================================
//FBE = FLL ByPassed External Clock	 
#define FBE_32KHZ    1   // 32 kHz crystal and 16 kHz fbus 

//FEE = FLL Enabled using External Clock
#define FEE_32K8BUS		0  // 32 kHz crystal and 8.39 MHz fbus  
#define FEE_32K16BUS	0  // 32 kHz crystal and 16.775 MHz fbus 

//FEI = FLL Enabled Internal Clock
#define FEI_8MBUS		  0  // fbus 17.77/2 MHz; untrimmed 


//=======================================================
//Enable OSC in stop mode
#define    OSCENINOFFMODE YES

//External Clock? 
#define		 EXT_CLK  NO
#if EXT_CLK   
		 #define C1REFS   0
#else 
		 #define C1REFS   1
#endif

//=======================================================
// DO NOT MODIFY  (BELOW)
//=======================================================
//FBE = FLL ByPassed External Clock
#if FBE_32KHZ
    #define C1HGO				0		 
    #define C1RANGE			0		 
    #define C1CLKS   		0b10    //CLKS = 10 for FBE
    #define C2MFD   		0b000   //N/A for FBE
    #define C2RFD   		0b000   //N/A for FBE
    #define SYS_CLOCK   32768
    #define BUS_CLOCK   SYS_CLOCK/2
//FEE = FLL Enabled External Clock
#elif	 FEE_32K8BUS
    #define C1HGO				0
    #define C1RANGE			0
    #define C1CLKS   		0b11  //CLKS = 11 for FEE
    #define C2MFD   		0b010
    #define C2RFD   		0b000
    #define SYS_CLOCK   32768
    #define BUS_CLOCK   16777216/2   //(crystal*P*N/R)/2

#elif	 FEE_32K16BUS
    #define C1HGO				0
    #define C1RANGE			0
    #define C1CLKS   		0b11  //CLKS = 11 for FEE
    #define C2MFD   		0b110
    #define C2RFD   		0b000
    #define SYS_CLOCK   32768
    #define BUS_CLOCK   33554432/2    
    
//FEI = FLL Enabled Internal Clock
#elif	 FEI_8MBUS			 //depends on trim
    #define C1HGO				0
    #define C1RANGE			0	     //N/A for FEI
    #define C1CLKS   		0b01	 //CLKS = 01 for FEI
    #define C2MFD   		0b010
    #define C2RFD   		0b000
    #define SYS_CLOCK   8864256
    #define BUS_CLOCK   8864256
#endif

#if  (FBE_32KHZ+FEE_32K8BUS+FEE_32K16BUS+FEI_8MBUS > 1		)
#error Select only ONE clock mode!!! 
#endif

#ifndef  C2MFD
#error MFD MUST BE DEFINED.  Select a clock mode!!! 
#endif
//=======================================================
// DO NOT MODIFY  (ABOVE)
//=======================================================


void CPU_init(void);

*/