#include <hidef.h>      /* common defines and macros */
#include <mc9s12hy64.h>     /* derivative information */

//******************************************************

#include "lcddrv.h"
#include "cpu.h"

#include "GD-5506P_DEMO9S12HY64.h"
#include "GD-5506P_enums.h"

#define D4B3


tU32  odometer_value, tripA_value, tripB_value;     // 1M miles requires at least 20 bits: 
                                                    // 1M  = 1111 0100 0010 0100 0000  
                                                    // 99k = 1111 0100 0010 0011 1111

tU08  temperature_value; // Temperature variable   

                   


/******************************************************************************
Function Name	:	Delay
Engineer		   :	r32151
Date			   :	02/06/00
Parameters		:	unsigned int delayTime
Returns			:	NONE
Notes			   :	Simple software delay dependent on CPU clock frequency and
					   compile strategy 
******************************************************************************/
void MDelay(unsigned long delayTime)					
  {
  unsigned long x;				 //outer loop counter 
  char y;									 //inner loop counter 

  for (x=0; x<delayTime; x++){for (y=0; y<100; y++){}}
  }


void  ConfigurePorts(void)
  {
  //***** CORE PORTS ******* 

  // core interrupts  
  // This register register was renamed. On early D, A and H families it is called INTCR,
  //   on all other families it is called IRQCR.  
  
  	IRQCR = 0;		// IRQ only responds to falling edge   
  								//	- note IRQE is write once  								

  //include this line to clear the X-bit in order to enable the XIRQ function     
  //  asm ANDCC #~BIT6;	

  	RDRIV = ALL_REDUCED_DRIVE;	// drive level 					// core ports reduced drive  
  	PUCR 	= ALL_PULLS_ON; 		// Enable Pull devices 	// Note: only pull-ups available on core ports  

  // configure port data and direction  
  // PORT A  
  	PORTA  = ALL_LOW;	   
  	DDRA   = ALL_INPUTS;
  // PORT B  
  	PORTB  = ALL_HIGH;	   					 		
  //****** PIM PORTS ******* 

    // PORT R  
  	PPSR 	= ALL_PULLED_DOWN;      // Configure Pull-polarity  
  	PERR 	= ALL_PULLS_ON;         // Enable Pull devices  
  	RDRR 	= ALL_REDUCED_DRIVE;    // drive level  
  	PTR 	= ALL_LOW;              // port data  
  	DDRR 	= ALL_INPUTS;           // port direction  

    // PORT T  
  	PPST 	= ALL_PULLED_DOWN;      // Configure Pull-polarity  
  	PERT 	= ALL_PULLS_ON;         // Enable Pull devices
  	RDRT 	= ALL_REDUCED_DRIVE;    // drive level  
  	PTT  	= ALL_LOW;              // port data  
  	DDRT 	= ALL_INPUTS;           // port direction 

    // PORT S  
  	DDRS = ALL_INPUTS;            //Set Port S as inputs
  	PPSS 	= ALL_PULLED_DOWN;      // Configure Pull-polarity  
  	PERS 	= ALL_PULLS_ON;	        // Enable Pull devices 
  //	PIES = 0xFF;                  // enable interrupts on PortS - edge sensitive 
  //	PPSS = 0xFF;                  // enable rise redge to set flag
  	
    //	PERS 	= BIT7|BIT6|BIT5|BIT4;					// S12 EVB - no pull devices on port S0-3 due to avoid   
  																	// conflict with connections to RS232 transceiver  
  	RDRS 	= ALL_REDUCED_DRIVE;    // drive level  
   	WOMS 	= 0x00;                 // Configure wired-or outputs  
  	PTS 	= ALL_LOW;	            // port data  

//  	DDRS 	= ALL_INPUTS;           // port direction  
  	DDRS 	= DDRS_DDRS1_MASK;      // port direction       // Test output

/*
    // PORT P  - Also LCD port!
  	PPSP 	= ALL_PULLED_UP;        // Configure Pull-polarity  
  	PERP 	= ALL_PULLS_ON;         // Enable Pull devices  
  	RDRP 	= ALL_REDUCED_DRIVE;    // drive level  
  	PTP 	= ALL_LOW;		          // port data  
  	DDRP 	= ALL_INPUTS;           // port direction  
*/  	
// These not recognized in CW header files  	
//  	PIFP 	= 0xFF;  // Clear all interrupt flags  
//  	PIEP 	= 0x00;  // Enable interrupts  

/*  
    // PORT H  - also LCD port!
  	PPSH 	= ALL_PULLED_DOWN;      // Configure Pull-polarity  
  	PERH 	= ALL_PULLS_ON;         // Enable Pull devices  
   	RDRH 	= ALL_REDUCED_DRIVE;    // drive level  
  	PTH   = ALL_LOW;	            // port data  
*/  	
  	// PORT U  
  	PPSU 	= ALL_PULLED_DOWN;      // Configure Pull-polarity  
  	PERU 	= ALL_PULLS_ON;         // Enable Pull devices  
  	PTU  	= ALL_LOW;	            // port data  
   	DDRU 	= DDRU_DDRU7_MASK | DDRU_DDRU6_MASK ;	  // port direction // two debug outputs  
  	
  	// PORT V  
  	PPSV 	= ALL_PULLED_DOWN;      // Configure Pull-polarity  
   	PERV 	= ALL_PULLS_ON;         // Enable Pull devices  
  	PTV   = ALL_LOW;	            // port data  
   	DDRV 	= DDRV_DDRV7_MASK | DDRV_DDRV6_MASK;	 // port direction   // two debug outputs  
  	


  //****** ATD PORTS ******* 
  // In order to use the digital input function the ATDIEN bit needs to be set  
  // ! NOTE: ATD port pull-ups are active for both digital and analog inputs !  
  //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 	

  //for PAD[7:0]  	
     PER1AD 	= ALL_PULLS_OFF;     // Port AD0 Pull-up Enable  
//  	 ATD.atddienh = 0x00;				// 1 = digital input enabled  
     RDR1AD 	= ALL_REDUCED_DRIVE; // Port AD0 Reduced Drive Register 1  
     PT1AD 	= ALL_LOW;	         // Port AD0 I/O Register 1  
     DDR1AD 	= ALL_INPUTS;        // Port AD0 Data Direction Register 1  


   //**** ECKL options **** 
   
  // ECLK available on PortH.2, 
  //  - note, keeping port H configured for reduced drive 
  //		 will minimise ECLK generated noise  							
  #ifdef ECLK_OUT
  // ECLKDIV = 1 to 32; DEFINED IN TARGET.H 
  // select one:  
     ECLKCTL = NECLK;                       // ECLKx2 on. ECLK              off  
  //   ECLKCTL = (ECLKDIV-1);               // ECLKx2 on.  ECLK/(ECLKDIV)     on  
  //   ECLKCTL = (ECLKDIV-1)|DIV16;         // ECLKx2 on.  ECLK/(ECLKDIV*16)  on  
  #endif
  }


void init_HY64(void) 
  {
  // initialise the system clock 
  CPMUSYNR    = 0xd8;         // configure the PLL 
  CPMUREFDIV  = 0x00;
  CPMUPOSTDIV = 0x00;
  while(!CPMUFLG_LOCK){}       // wait for PLL to lock 
  CPMUCLKS_PLLSEL = 1;         //select the PLL as the clock source 
/*
  // Initialise the memory controller prior to any commands being launched or EEE data access 
  while (!FTM.fstat.bit.ccif) {}					// wait for FTM reset to complete 
  
  FTM.fclkdiv  = FCLK_PRESCALER; 
*/  
  }


void main(void) 
  {
  tU08 count =0;
  tU08 i,l,V,temperature_ctr;
  byte result, inputcounter, c;



  init_HY64();          // Initialize clocks
  ConfigurePorts();			// Configure I/O ports
 // Moto_init();
  LCD_init();           // Configure LCD, enables all FP pins & LCD

  
  //-------------------------
  LCD_RAM_SET_ALL();      // Set all LCD segments
  LCD_RAM_CLEAR_ALL();    // Clear all LCD segments

  SET_LOGO(ON,ON,ON,ON,ON);          // local_lcdrammode, FSL_logo, HY_64_Part_Num, Jellyfish_Name

  EnableInterrupts;
  
  DDRS  = 0x02;  PTS = 0x00;

  //Demo Code ******************

  l=0; V=0; temperature_ctr=0; inputcounter = 0;     //Initialize display counters
  odometer_value = 0;                                // Reset Odometer value to 0 at reset
    
//--SET_TEMPSEGS(RAM mode, temp_type, temp_scale, char col4);----------------------
 // SET_TEMPSEGS(SEGONOFF, inside_temp, F,ON);     // Display Temp Segments - Case 1: 
//  SET_TEMPSEGS(outside_temp,F,ON);               // Display Temp Segments - Case 2
 // SET_TEMPSEGS(SEGONOFF, engine_temp, F,ON);     // Display Temp Segments - Case 3
 // SET_TEMPSEGS(SEGONOFF, inside_temp, C,ON);     // Display Temp Segments - Case 4
 // SET_TEMPSEGS(SEGONOFF, outside_temp,C,ON);     // Display Temp Segments - Case 5
  SET_TEMPSEGS(engine_temp, C,ON);     // Display Temp Segments - Case 6

  for(;;) 
    {
        
    MDelay(4000);

 	  if (l == 8) l=0; else l++;;   // Update compass "value"
    SET_GEAR(ON,l);      // Rolls through gear selector
    
    switch(l) 
      {
      case 0:   SET_COMPASS(ON,N);  break; // update compass
      case 1:   SET_COMPASS(ON,NE); break; // update compass
      case 2:   SET_COMPASS(ON,E);  break; // update compass
      case 3:   SET_COMPASS(ON,SE); break; // update compass
      case 4:   SET_COMPASS(ON,S);  break; // update compass
      case 5:   SET_COMPASS(ON,SW); break; // update compass
      case 6:   SET_COMPASS(ON,W);  break; // update compass
      case 7:   SET_COMPASS(ON,NW); break; // update compass
      }

    SET_VOLT_BAR(ON, V);
    SET_TEMP_BAR(ON, (6-V)); // Update Temp Bar Graph w/inverse of Voltage Graph

 	  if (V == 6) V=0; else V++;;   // Update Voltage Bar Graph "value"
 	  
 	  
 	  SET_TEMP_DIGITS(ON,temperature_ctr);   // Update temperature digits with value of i
    temperature_ctr++; if (temperature_ctr==255) temperature_ctr=0; 
    
    
    if (PTS_PTS5 == 1)  // used to toggle between ODO/TRIPA/TRIP B on PTS5 press
      {
        count=count++;
        if (count == 3)
          { 
            count=0; 
          }   
      }

     switch(count)   
      {
        // ODOMETER
        case 0: SET_ODO_TITLE (ON,ON,OFF,OFF,OFF);   // (ODO, MILES, TRIPA, TRIPB, KM) -->SEGs
                SET_ODO_DIGITS(ON,odometer_value);   // Update odometer digits with global odometer value
                odometer_value++; if (odometer_value==1000000) odometer_value=0; break;
                      
        //TRIP A Meter
        case 1: SET_ODO_TITLE (OFF,ON,ON,OFF,OFF);   // (ODO, MILES, TRIPA, TRIPB, KM) -->SEGs
                SET_TRIPA_DIGITS(ON,tripA_value);   // Update tripA digits with global tripA value
                tripA_value++; if (tripA_value==1000000) tripA_value=0; 
                odometer_value++; if (odometer_value==1000000) odometer_value=0; break; //must keep odometer incrementing
      
        //TRIP B meter
        case 2: SET_ODO_TITLE (OFF,ON,OFF,ON,OFF);   // (ODO, MILES, TRIPA, TRIPB, KM) -->SEGs
                SET_TRIPB_DIGITS(ON,tripB_value);   // Update tripB digits with global odometer value
                tripB_value++; if (tripB_value==1000000) tripB_value=0; 
                odometer_value++; if (odometer_value==1000000) odometer_value=0;break;  //must keep odometer incrementing
      }
    
    } // wait forever 
  // please make sure that you never leave this function 
  
 }           
    
 /*   SET_ODO_DIGITS(ON,odometer_value);   // Update odometer digits with global odometer value
    odometer_value++; if (odometer_value==1000000) odometer_value=0;

    SET_TRIPA_DIGITS(ON,tripA_value);   // Update odometer digits with global odometer value
    tripA_value++; if (tripA_value==1000000) tripA_value=0;
    
    SET_TRIPB_DIGITS(ON,tripB_value);   // Update odometer digits with global odometer value
    tripB_value++; if (tripB_value==1000000) tripB_value=0;    
    
  */
